<?xml version="1.0" encoding="iso-8859-1"?> 
<xsl:stylesheet 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsd="http://www.w3.org/2001/XMLSchema"
	version="1.0">

<xsl:output method="xml" encoding="UTF-8"/>

<xsl:strip-space elements="*"/>
	
	<xsl:template match="xsd:element[xsd:element]">
		<xsd:element>
			<xsl:copy-of select="@*"/>
			<xsl:choose>
				<xsl:when test="@name='ArchiveTransfer'">
					<xsl:apply-templates select="xsd:element[@name='Comment']" />
					<xsl:apply-templates select="xsd:element[@name='Date']" />
					<xsl:apply-templates select="xsd:element[@name='RelatedTransferReference']" />
					<xsl:apply-templates select="xsd:element[@name='TransferIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='TransferRequestReplyIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='TransferringAgency']" />
					<xsl:apply-templates select="xsd:element[@name='ArchivalAgency']" />
					<xsl:apply-templates select="xsd:element[@name='Integrity']" />
					<xsl:apply-templates select="xsd:element[@name='NonRepudiation']" />
					<xsl:apply-templates select="xsd:element[@name='Contains']" />
				</xsl:when>
				<xsl:when test="@name='AccessRestriction'">
					<xsl:apply-templates select="xsd:element[@name='Code']" />
					<xsl:apply-templates select="xsd:element[@name='StartDate']" />
				</xsl:when>
				<xsl:when test="@name='Address'">
					<xsl:apply-templates select="xsd:element[@name='BlockName']" />
					<xsl:apply-templates select="xsd:element[@name='BuildingName']" />
					<xsl:apply-templates select="xsd:element[@name='BuildingNumber']" />
					<xsl:apply-templates select="xsd:element[@name='CityName']" />
					<xsl:apply-templates select="xsd:element[@name='CitySub-DivisionName']" />
					<xsl:apply-templates select="xsd:element[@name='Country']" />
					<xsl:apply-templates select="xsd:element[@name='FloorIdentification']" />
					<xsl:apply-templates select="xsd:element[@name='Postcode']" />
					<xsl:apply-templates select="xsd:element[@name='PostOfficeBox']" />
					<xsl:apply-templates select="xsd:element[@name='RoomIdentification']" />
					<xsl:apply-templates select="xsd:element[@name='StreetName']" />
				</xsl:when>
				<xsl:when test="@name='Appraisal'">
					<xsl:apply-templates select="xsd:element[@name='Code']" />
					<xsl:apply-templates select="xsd:element[@name='Duration']" />
					<xsl:apply-templates select="xsd:element[@name='StartDate']" />
				</xsl:when>
				<xsl:when test="@type='ArchiveType'">
					<xsl:apply-templates select="xsd:element[@name='ArchivalAgencyArchiveIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='ArchivalAgreement']" />
					<xsl:apply-templates select="xsd:element[@name='ArchivalProfile']" />
					<xsl:apply-templates select="xsd:element[@name='DescriptionLanguage']" />
					<xsl:apply-templates select="xsd:element[@name='DescriptionLevel']" />
					<xsl:apply-templates select="xsd:element[@name='Name']" />
					<xsl:apply-templates select="xsd:element[@name='ServiceLevel']" />
					<xsl:apply-templates select="xsd:element[@name='TransferringAgencyArchiveIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='ContentDescription']" />
					<xsl:apply-templates select="xsd:element[@name='Appraisal']" />
					<xsl:apply-templates select="xsd:element[@name='AccessRestriction']" />
					<xsl:apply-templates select="xsd:element[@name='Document']" />
					<xsl:apply-templates select="xsd:element[@name='Contains']" />
				</xsl:when>
				<xsl:when test="@type='ArchiveObjectType'">
					<xsl:apply-templates select="xsd:element[@name='ArchivalAgencyObjectIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='DescriptionLevel']" />
					<xsl:apply-templates select="xsd:element[@name='Name']" />
					<xsl:apply-templates select="xsd:element[@name='TransferringAgencyObjectIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='ContentDescription']" />
					<xsl:apply-templates select="xsd:element[@name='Appraisal']" />
					<xsl:apply-templates select="xsd:element[@name='AccessRestriction']" />
					<xsl:apply-templates select="xsd:element[@name='Document']" />
					<xsl:apply-templates select="xsd:element[@name='Contains']" />
				</xsl:when>
				<xsl:when test="@name='Communication'">
					<xsl:apply-templates select="xsd:element[@name='Channel']" />
					<xsl:apply-templates select="xsd:element[@name='CompleteNumber']" />
					<xsl:apply-templates select="xsd:element[@name='URI']" />
				</xsl:when>
				<xsl:when test="@name='Contact'">
					<xsl:apply-templates select="xsd:element[@name='DepartmentName']" />
					<xsl:apply-templates select="xsd:element[@name='Identification']" />
					<xsl:apply-templates select="xsd:element[@name='PersonName']" />
					<xsl:apply-templates select="xsd:element[@name='Responsibility']" />
					<xsl:apply-templates select="xsd:element[@name='Address']" />
					<xsl:apply-templates select="xsd:element[@name='Communication']" />
				</xsl:when>
				<xsl:when test="@name='ContentDescription'">
					<xsl:apply-templates select="xsd:element[@name='CustodialHistory']" />
					<xsl:apply-templates select="xsd:element[@name='Description']" />
					<xsl:apply-templates select="xsd:element[@name='FilePlanPosition']" />
					<xsl:apply-templates select="xsd:element[@name='Format']" />
					<xsl:apply-templates select="xsd:element[@name='Language']" />
					<xsl:apply-templates select="xsd:element[@name='LatestDate']" />
					<xsl:apply-templates select="xsd:element[@name='OldestDate']" />
					<xsl:apply-templates select="xsd:element[@name='OtherDescriptiveData']" />
					<xsl:apply-templates select="xsd:element[@name='RelatedObjectReference']" />
					<xsl:apply-templates select="xsd:element[@name='Size']" />
					<xsl:apply-templates select="xsd:element[@name='OriginatingAgency']" />
					<xsl:apply-templates select="xsd:element[@name='Repository']" />
					<xsl:apply-templates select="xsd:element[@name='ContentDescriptive']" />
					<xsl:apply-templates select="xsd:element[@name='AccessRestriction']" /> 
					<xsl:apply-templates select="xsd:element[@name='OtherMetadata']" /> 
				</xsl:when>
				<xsl:when test="@name='ContentDescription'">
					<xsl:apply-templates select="xsd:element[@name='AccessRestriction']" /> 
					<xsl:apply-templates select="xsd:element[@name='KeywordContent']" />
					<xsl:apply-templates select="xsd:element[@name='KeywordReference']" />
					<xsl:apply-templates select="xsd:element[@name='KeywordType']" />
				</xsl:when>
				<xsl:when test="@name='Organization'">
					<xsl:apply-templates select="xsd:element[@name='BusinessType']" />
					<xsl:apply-templates select="xsd:element[@name='Description']" />
					<xsl:apply-templates select="xsd:element[@name='Identification']" />
					<xsl:apply-templates select="xsd:element[@name='LegalClassification']" />
					<xsl:apply-templates select="xsd:element[@name='Name']" />
					<xsl:apply-templates select="xsd:element[@name='Contact']" />
					<xsl:apply-templates select="xsd:element[@name='Address']" />
					<xsl:apply-templates select="xsd:element[@name='Communication']" />
				</xsl:when>				
				<xsl:otherwise>
					<xsl:apply-templates/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:copy-of select="xsd:attribute"/>
			<xsl:copy-of select="xsd:annotation"/>
		</xsd:element>
	</xsl:template>
	
	<xsl:template match="xsd:element[not(xsd:element)]">
		<xsl:copy-of select="."/>
	</xsl:template>

</xsl:stylesheet>
		